## nfstrace 0.3.1

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.12)
project (nfstrace)

# check compiler and packages ==================================================
if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
    if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.8)
        message (FATAL_ERROR "GCC version must be at least 4.8")
    endif ()
elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
    if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 3.3)
        message (FATAL_ERROR "Clang version must be at least 3.3")
    endif ()
else ()
    message (WARNING "Compilation by ${CMAKE_CXX_COMPILER_ID} ${CMAKE_CXX_COMPILER_VERSION} isn't tested")
endif ()

find_package(Threads REQUIRED) # POSIX Threads

find_path(PCAP_ROOT_DIR
          NAMES include/pcap.h)

find_library(PCAP_LIBRARY
             NAMES pcap
             HINTS ${PCAP_ROOT_DIR}/lib)

if ("${PCAP_LIBRARY}" STREQUAL "PCAP_LIBRARY-NOTFOUND")
    message (FATAL_ERROR "Could NOT find PCAP")
endif ()

# build application ============================================================
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -pedantic -Wall -Werror -Wextra -fPIC -fvisibility=hidden")
set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--export-dynamic")

if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
    set (CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} --coverage -O0")
endif ()

# Read version string from file
file(STRINGS VERSION NST_VERSION)

string (REPLACE "." ";" VERSION_LIST ${NST_VERSION})
list(GET VERSION_LIST 0 NST_V_MAJOR)
list(GET VERSION_LIST 1 NST_V_MINOR)
list(GET VERSION_LIST 2 NST_V_PATCH)

set (NST_VERSION_FULL "${PROJECT_NAME} ${NST_VERSION} (${CMAKE_BUILD_TYPE})")

string(TIMESTAMP COMPILATION_DATE "%Y-%m-%d")

include_directories (src)
file (GLOB_RECURSE SRCS "src/*.cpp")
set  (LIBS  ${CMAKE_DL_LIBS}            # libdl with dlopen()
            ${CMAKE_THREAD_LIBS_INIT}   # libpthread
            ${PCAP_LIBRARY}             # libpcap
            )

configure_file(docs/nfstrace.8.in              ${PROJECT_SOURCE_DIR}/docs/nfstrace.8)
configure_file(src/api/plugin_api.h.in         ${PROJECT_SOURCE_DIR}/src/api/plugin_api.h)
configure_file(src/controller/build_info.h.in  ${PROJECT_SOURCE_DIR}/src/controller/build_info.h)

add_executable        (${PROJECT_NAME} ${SRCS})
target_link_libraries (${PROJECT_NAME} ${LIBS})

# build watch analyzer==========================================================
add_subdirectory(analyzers)

# testing ======================================================================
enable_testing ()
add_subdirectory (tests)

# installation of main application =============================================
install (TARGETS "${PROJECT_NAME}" RUNTIME DESTINATION bin)

# installation of api headers ==================================================
file (GLOB headers "src/api/*.h")
install (FILES ${headers} DESTINATION include/nfstrace/api)

# installation of man page =====================================================
install (FILES ${PROJECT_SOURCE_DIR}/docs/nfstrace.8 DESTINATION share/man/man8)

# build packages ===============================================================
set (CPACK_PACKAGE_VERSION ${NST_VERSION})
set (CPACK_PACKAGING_INSTALL_PREFIX "/usr")
set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "NFS tracing/monitoring/capturing/statistic tool")
set (CPACK_PACKAGE_CONTACT "Nfstrace developers <nfstrace@epam.com>")

set (CPACK_RPM_PACKAGE_GROUP "Applications/Internet")
set (CPACK_RPM_PACKAGE_LICENSE "GPLv2")
set (CPACK_RPM_PACKAGE_VENDOR "EPAM Systems")
set (CPACK_RPM_EXCLUDE_FROM_AUTO_FILELIST_ADDITION /usr/share/man /usr/share/man/man8)
set (CPACK_RPM_PACKAGE_REQUIRES "libpcap >= 1.3.0-1")

set (CPACK_DEBIAN_PACKAGE_SECTION "admin")
set (CPACK_DEBIAN_PACKAGE_DEPENDS "libpcap0.8 (>=1.3.0-1)")

include (CPack)

# coverage =====================================================================
if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
    find_program (GCOVR_PATH gcovr)

    if (GCOVR_PATH)
        add_custom_target (coverage
                           COMMAND ${GCOVR_PATH} --xml -r \"${CMAKE_SOURCE_DIR}\" --object-directory \"${CMAKE_BINARY_DIR}\" -o coverage.xml 2>&1 >/dev/null
                           WORKING_DIRECTORY ${CMAKE_PROJECT_DIR})
    endif ()
endif ()

# documentation ================================================================

find_program (DOXYGEN_PATH doxygen)

if (DOXYGEN_PATH)
    add_custom_target (documentation
                       COMMAND ${DOXYGEN_PATH} Doxyfile
                       WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
endif ()

=== analyzers/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.12)

# build analyzers ==============================================================
add_library (breakdown    MODULE src/breakdown/breakdown_analyzer.cpp)
add_library (ofws         MODULE src/ofws/ofws_analyzer.cpp)
add_library (ofdws        MODULE src/ofdws/ofdws_analyzer.cpp
                                 src/ofdws/file_rw_op.cpp)
add_library (testanalyzer MODULE src/test/test_analyzer.cpp)
set_target_properties (breakdown ofws ofdws testanalyzer
                       PROPERTIES LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/analyzers"
                       NO_SONAME ON)
add_subdirectory (src/watch)

# installation of plugins ======================================================
install (TARGETS breakdown ofws ofdws LIBRARY DESTINATION lib/nfstrace)

=== tests/functional/CMakeLists.txt ===
set (CHECK_TRACE_SCRIPT "check-compressed-trace.sh")
configure_file ("${CHECK_TRACE_SCRIPT}.in" "${CHECK_TRACE_SCRIPT}")
set (CHECK_DRANE_SCRIPT "check-compressed-drane.sh")
configure_file ("${CHECK_DRANE_SCRIPT}.in" "${CHECK_DRANE_SCRIPT}")
set (CHECK_OUTPUT_SCRIPT "check-output.sh")
configure_file ("${CHECK_OUTPUT_SCRIPT}.in" "${CHECK_OUTPUT_SCRIPT}")

# Adding trace/drane/output tests for each .pcap.bz2 trace
file (GLOB traces "${CMAKE_SOURCE_DIR}/traces/*.pcap.bz2")
foreach (trace ${traces})
    get_filename_component (name ${trace} NAME)
    get_filename_component (path ${trace} PATH)
    set (result ${CMAKE_BINARY_DIR}/Testing/Temporary/${name}.res)
    set (reference ${path}/references/${name}.ref)

    add_test (NAME stat:${name} COMMAND sh ${CHECK_TRACE_SCRIPT} ${trace} ${result} ${reference})
    add_test (NAME drain:${name} COMMAND sh ${CHECK_DRANE_SCRIPT} ${trace} ${result} ${reference})
    add_test (NAME out:${name} COMMAND sh ${CHECK_OUTPUT_SCRIPT} ${trace})
endforeach ()

=== tests/unit/CMakeLists.txt ===
if ("${GMOCK_SOURCE_DIR}" STREQUAL "")
    message ("GMOCK_SOURCE_DIR variable not set - unit-tests are not available. Use '-DGMOCK_SOURCE_DIR=<path_to_gmock_sources>' param for CMake")
else ()
    # Clang and GCC 4.9+ cause errors on GMock/GTest compilation, so we are adding following flags to suppress them
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-missing-field-initializers -Wno-sign-compare -Wno-unused-private-field")
    set (gmock_force_shared_crt true CACHE INTERNAL "")
    set (BUILD_SHARED_LIBS false CACHE INTERNAL "")
    add_subdirectory (${GMOCK_SOURCE_DIR} ${CMAKE_BINARY_DIR}/gmock)
    set (GMOCK_LIBRARIES gmock)
    set (GMOCK_INCLUDE_DIRS "${GMOCK_SOURCE_DIR}/include"
	"${GMOCK_SOURCE_DIR}/gtest/include")
    include_directories (${CMAKE_SOURCE_DIR}/src ${GMOCK_INCLUDE_DIRS} ${GMOCK_SOURCE_DIR})

    add_subdirectory (utils)
endif ()

=== analyzers/src/watch/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.12)
project (watch)

# check system dependencies instructions =======================================
find_package (Curses) # find ncurses library

# build instructions ===========================================================
if (CURSES_FOUND)
    include_directories (${CMAKE_CURRENT_SOURCE_DIR})
    include_directories (${CURSES_INCLUDE_DIR})
    file (GLOB_RECURSE UTILS ../utils/*.cpp)
    file (GLOB_RECURSE SRCS ./*.cpp)
    add_library (${PROJECT_NAME} SHARED ${UTILS} ${SRCS})
    set_target_properties(${PROJECT_NAME}
                          PROPERTIES LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/analyzers # direct output to nfstrace common binary dir
                          NO_SONAME ON)
    target_link_libraries (${PROJECT_NAME} ${CURSES_LIBRARIES})
    install (TARGETS watch LIBRARY DESTINATION lib/nfstrace)
else ()
    message (WARNING "CURSES library not found - libwatch plugin is not available!")
endif ()

=== tests/unit/utils/CMakeLists.txt ===
set(UTILS_TEST_EXECUTABLE test_utils)
aux_source_directory("." SRC_TEST_LIST)
add_executable(${UTILS_TEST_EXECUTABLE} ${SRC_TEST_LIST})
target_link_libraries(${UTILS_TEST_EXECUTABLE} ${GMOCK_LIBRARIES})
add_test(test_utils ${UTILS_TEST_EXECUTABLE})

=== debian/changelog ===
nfstrace (0.3.1-2) unstable; urgency=medium

  * Add dependency on ncurses.
  * Fix build failure on kFreeBSD.

 -- Andrew Shadura <andrewsh@debian.org>  Thu, 18 Dec 2014 13:15:34 +0100

nfstrace (0.3.1-1) unstable; urgency=medium

  * New upstream release.

 -- Andrew Shadura <andrewsh@debian.org>  Thu, 18 Dec 2014 12:12:48 +0100

nfstrace (0.3.0-1) unstable; urgency=low

  * Initial release (Closes: #769397).

 -- Andrew Shadura <andrewsh@debian.org>  Tue, 18 Nov 2014 15:39:40 +0100

=== debian/control ===
Source: nfstrace
Section: net
Priority: optional
Maintainer: Andrew Shadura <andrewsh@debian.org>
Build-Depends:
    debhelper (>= 9),
    cmake,
    g++ (>= 4.8) | clang (>= 3.3),
    libpcap0.8-dev (>= 1.3),
    libgtest-dev,
    google-mock,
    libncurses5-dev
Standards-Version: 3.9.5
Homepage: https://github.com/epam/nfstrace/

Package: nfstrace
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: NFS tracing/monitoring/capturing/analyzing tool
 nfstrace captures live NFS traffic and performs filtering, statistical
 analysis, visualisation and more. It also provides an API for custom
 pluggable analysis modules.
 .
 nfstrace currently supports the following protocols:
 .
  - Ethernet
  - IPv4, IPv6
  - UDP, TCP
  - NFSv3, NFSv4

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DGMOCK_SOURCE_DIR=/usr/src/gmock

.PHONY: override_dh_auto_configure

=== debian/watch ===
# watch control file for uscan
# See uscan(1) for how to set this file properly

version=3

https://github.com/epam/nfstrace/tags .*/(\d[\d\.]*)\.(?:tar.gz|tar.bz2|tar.xz)

## nfstrace 0.4.1

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.12)
project (nfstrace)

# check compiler and packages ==================================================
if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
    if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.8)
        message (FATAL_ERROR "GCC version must be at least 4.8")
    endif ()
elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
    if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 3.3)
        message (FATAL_ERROR "Clang version must be at least 3.3")
    endif ()
else ()
    message (WARNING "Compilation by ${CMAKE_CXX_COMPILER_ID} ${CMAKE_CXX_COMPILER_VERSION} isn't tested")
endif ()

include(cmake/options.cmake)

find_package(Threads REQUIRED) # POSIX Threads

find_path(PCAP_ROOT_DIR
          NAMES include/pcap.h)

find_library(PCAP_LIBRARY
             NAMES pcap
             HINTS ${PCAP_ROOT_DIR}/lib)

if ("${PCAP_LIBRARY}" STREQUAL "PCAP_LIBRARY-NOTFOUND")
    message (FATAL_ERROR "Could NOT find PCAP")
endif ()

# build application ============================================================
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -pedantic -Wall -Werror -Wextra -fPIC -fvisibility=hidden")
set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--export-dynamic")

if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU" AND "${INCLUDE_COVERAGE_INFO}")
    set (CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} --coverage -O0")
endif ()

# Read version string from file
file (STRINGS VERSION NST_VERSION)

string (REPLACE "." ";" VERSION_LIST ${NST_VERSION})
list (GET VERSION_LIST 0 NST_V_MAJOR)
list (GET VERSION_LIST 1 NST_V_MINOR)
list (GET VERSION_LIST 2 NST_V_PATCH)

set (NST_VERSION_FULL "${PROJECT_NAME} ${NST_VERSION} (${CMAKE_BUILD_TYPE})")

string (TIMESTAMP COMPILATION_DATE "%Y-%m-%d")

include_directories (src)

# nfstrace executable ==========================================================
file (GLOB_RECURSE SRCS "src/*.cpp")
set (LIBS ${CMAKE_DL_LIBS}          # libdl with dlopen()
          ${CMAKE_THREAD_LIBS_INIT} # libpthread
          ${PCAP_LIBRARY}           # libpcap
          )

configure_file (docs/nfstrace.8.in              ${PROJECT_SOURCE_DIR}/docs/nfstrace.8)
configure_file (src/api/plugin_api.h.in         ${PROJECT_SOURCE_DIR}/src/api/plugin_api.h)
configure_file (src/controller/build_info.h.in  ${PROJECT_SOURCE_DIR}/src/controller/build_info.h)

add_executable (${PROJECT_NAME} ${SRCS})
target_link_libraries (${PROJECT_NAME} ${LIBS})

# analyzer plugins =============================================================
add_subdirectory (analyzers)

# testing ======================================================================
enable_testing ()
add_subdirectory (tests)

# installation of main application =============================================
install (TARGETS "${PROJECT_NAME}" RUNTIME DESTINATION bin)

# installation of api headers ==================================================
file (GLOB headers "src/api/*.h")
install (FILES ${headers} DESTINATION include/nfstrace/api)

# installation of man page =====================================================
install (FILES ${PROJECT_SOURCE_DIR}/docs/nfstrace.8 DESTINATION share/man/man8)

# build packages ===============================================================
include ("cmake/packaging.cmake")

# coverage =====================================================================
if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU" AND "${INCLUDE_COVERAGE_INFO}")
    find_program (GCOVR_PATH gcovr)

    if (GCOVR_PATH)
        add_custom_target (coverage
                           COMMAND ${GCOVR_PATH} --xml -r \"${CMAKE_SOURCE_DIR}\" --object-directory \"${CMAKE_BINARY_DIR}\" -o coverage.xml 2>&1 >/dev/null
                           WORKING_DIRECTORY ${CMAKE_BINARY_DIR})
        add_custom_target (coverage-html
                           COMMAND ${GCOVR_PATH} --html --html-details -r \"${CMAKE_SOURCE_DIR}\" --object-directory \"${CMAKE_BINARY_DIR}\" -o coverage.html 2>&1 >/dev/null
                           WORKING_DIRECTORY ${CMAKE_BINARY_DIR})
    else ()
        message (WARNING "'gcovr' executable not found - coverage report is not available.")
    endif ()
endif ()

# documentation ================================================================
add_subdirectory (docs)

# code style ===================================================================
find_program (ASTYLE_PATH astyle)

if (ASTYLE_PATH)
    add_custom_target (codestyle
                       COMMAND find analyzers src tests -name '*.h' -o -name '*.cpp' |
                               xargs ${ASTYLE_PATH} --options=${CMAKE_SOURCE_DIR}/astyle.cfg
                       WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
endif ()

# valgrind reports =============================================================
include ("cmake/valgrind.cmake")

=== docs/CMakeLists.txt ===
add_custom_target (documentation)

find_program (DOXYGEN_PATH doxygen)
if (DOXYGEN_PATH)
    add_custom_target (documentation-doxygen
                       COMMAND ${DOXYGEN_PATH} Doxyfile
                       WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
    add_dependencies (documentation documentation-doxygen)
else ()
    message (WARNING "Doxygen is not found - source-code documentation is not available")
endif ()

=== tests/unit/CMakeLists.txt ===
if ("${GMOCK_SOURCE_DIR}" STREQUAL "")
    message (WARNING "GMOCK_SOURCE_DIR variable not set - unit-tests are not available. Use '-DGMOCK_SOURCE_DIR=<path_to_gmock_sources>' param for CMake")
else ()
    # Clang and GCC 4.9+ cause errors on GMock/GTest compilation, so we are adding following flags to suppress them
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-missing-field-initializers")
    if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
        set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-private-field")
    endif ()
    set (gmock_force_shared_crt true CACHE INTERNAL "")
    set (BUILD_SHARED_LIBS false CACHE INTERNAL "")
    add_definitions (-DGTEST_HAS_PTHREAD=1) # It fixes BUG in GTests in BSD
    add_subdirectory (${GMOCK_SOURCE_DIR} ${CMAKE_BINARY_DIR}/gmock)
    set (GMOCK_LIBRARIES gmock gmock_main)
    set (GMOCK_INCLUDE_DIRS "${GMOCK_SOURCE_DIR}/include"
        "${GMOCK_SOURCE_DIR}/gtest/include"
        "${GMOCK_SOURCE_DIR}")

    include_directories (${CMAKE_SOURCE_DIR}/src ${GMOCK_INCLUDE_DIRS})

    add_subdirectory (utils)
    add_subdirectory (analyzers)
    add_subdirectory (protocols)
    add_subdirectory (filtration)
endif ()

=== analyzers/src/breakdown/CMakeLists.txt ===
project (breakdown)
aux_source_directory (${CMAKE_SOURCE_DIR}/analyzers/src/breakdown SRC_TEST_LIST)
add_library (${PROJECT_NAME} SHARED ${SRC_TEST_LIST})
set_target_properties (breakdown
                       PROPERTIES LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/analyzers"
                       NO_SONAME ON)
install (TARGETS breakdown LIBRARY DESTINATION lib/nfstrace)

=== tests/unit/analyzers/CMakeLists.txt ===
add_subdirectory (breakdown)

project (unit_test_parse)
aux_source_directory ("." SRC_TEST_LIST)
aux_source_directory (${CMAKE_SOURCE_DIR}/src/protocols/cifs SRC_TEST_LIST)
aux_source_directory (${CMAKE_SOURCE_DIR}/src/protocols/cifs2 SRC_TEST_LIST)
aux_source_directory (${CMAKE_SOURCE_DIR}/src/protocols/nfs SRC_TEST_LIST)
aux_source_directory (${CMAKE_SOURCE_DIR}/src/protocols/netbios SRC_TEST_LIST)
add_executable (${PROJECT_NAME} ${SRC_TEST_LIST}
    ${CMAKE_SOURCE_DIR}/src/analysis/cifs_parser.cpp
    ${CMAKE_SOURCE_DIR}/src/utils/out.cpp
    ${CMAKE_SOURCE_DIR}/src/utils/log.cpp
    ${CMAKE_SOURCE_DIR}/src/utils/sessions.cpp
)
target_link_libraries (${PROJECT_NAME} ${GMOCK_LIBRARIES})
add_test (${PROJECT_NAME} ${PROJECT_NAME})

=== debian/changelog ===
nfstrace (0.4.1-1build1) xenial; urgency=medium

  * No-change rebuild for ncurses6 transition.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 07 Feb 2016 09:43:58 +0000

nfstrace (0.4.1-1) unstable; urgency=medium

  * New upstream release.
  * Update watch file to mangle the tarball filename.
  * Drop patches applied upstream.

 -- Andrew Shadura <andrewsh@debian.org>  Thu, 12 Nov 2015 19:17:45 +0100

nfstrace (0.4.0-3) unstable; urgency=medium

  * Apply more patches from upstream fixing FTBFS (Closes: #786801).

 -- Andrew Shadura <andrewsh@debian.org>  Thu, 23 Jul 2015 20:04:14 +0200

nfstrace (0.4.0-2) unstable; urgency=medium

  * Apply patches from upstream fixing FTBFS (Closes: #786801).

 -- Andrew Shadura <andrewsh@debian.org>  Tue, 16 Jun 2015 00:00:07 +0200

nfstrace (0.4.0-1) unstable; urgency=medium

  * New upstream release
  * Build documentation using LibreOffice
  * Depend on libjson-c-dev

 -- Andrew Shadura <andrewsh@debian.org>  Tue, 05 May 2015 15:17:33 +0200

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,11 @@
     libpcap0.8-dev (>= 1.3),
     libgtest-dev,
     google-mock,
-    libncurses5-dev
+    libncurses5-dev,
+    libjson-c-dev
+Build-Depends-Indep:
+#   doxygen,
+    libreoffice-writer
 Standards-Version: 3.9.5
 Homepage: https://github.com/epam/nfstrace/
 
@@ -17,6 +21,7 @@
 Architecture: any
 Multi-Arch: foreign
 Depends: ${misc:Depends}, ${shlibs:Depends}
+Recommends: nfstrace-doc
 Description: NFS tracing/monitoring/capturing/analyzing tool
  nfstrace captures live NFS traffic and performs filtering, statistical
  analysis, visualisation and more. It also provides an API for custom
@@ -27,4 +32,14 @@
   - Ethernet
   - IPv4, IPv6
   - UDP, TCP
-  - NFSv3, NFSv4
+  - NFSv3, NFSv4, CIFS
+
+Package: nfstrace-doc
+Architecture: all
+Depends: ${misc:Depends}
+Description: NFS tracing/monitoring/capturing/analyzing tool (documentation)
+ nfstrace captures live NFS traffic and performs filtering, statistical
+ analysis, visualisation and more. It also provides an API for custom
+ pluggable analysis modules.
+ .
+ This package ships the documentation for nfstrace.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_build-indep:
	cd docs; \
	unset DISPLAY; \
	loffice --headless --convert-to pdf nfstrace_manual.docx
	# PlantUML not available :(
	# $(MAKE) -C docs

override_dh_auto_test-indep:

override_dh_auto_configure:
	dh_auto_configure -- -DGMOCK_SOURCE_DIR=/usr/src/gmock

override_dh_auto_install-indep:

.PHONY: override_dh_auto_configure override_dh_auto_build-indep override_dh_auto_test-indep override_dh_auto_install-indep

## nfstrace 0.4.2

=== debian/changelog ===
nfstrace (0.4.2-2ubuntu3) yakkety; urgency=medium

  * debian/patches/no-unaligned-access.patch: Fix unaligned access in
    buffer copies.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 05 Oct 2016 20:48:54 -0700

nfstrace (0.4.2-2ubuntu2) yakkety; urgency=medium

  * More complete FTBFS fix.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 04 Oct 2016 00:32:51 -0700

nfstrace (0.4.2-2ubuntu1) yakkety; urgency=medium

  * debian/patches/gcc6-ftbfs.patch: Fix FTBFS with gcc6.  Closes: #835644.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 04 Oct 2016 00:17:43 -0700

nfstrace (0.4.2-2) unstable; urgency=medium

  * Tests fail on sparc64 and x32, ignore the failures for now.

 -- Andrew Shadura <andrewsh@debian.org>  Fri, 22 Jul 2016 16:39:14 +0200

nfstrace (0.4.2-1) unstable; urgency=medium

  * New upstream release (Closes: #831116).
  * Make the build reproducible (Closes: #831570).
  * Make the documentation buildable again.

 -- Andrew Shadura <andrewsh@debian.org>  Wed, 20 Jul 2016 11:16:55 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: nfstrace
 Section: net
 Priority: optional
-Maintainer: Andrew Shadura <andrewsh@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Andrew Shadura <andrewsh@debian.org>
 Build-Depends:
     debhelper (>= 9),
     cmake,
@@ -12,8 +13,12 @@
     libncurses5-dev,
     libjson-c-dev
 Build-Depends-Indep:
-#   doxygen,
-    libreoffice-writer
+    doxygen,
+    graphviz,
+    texlive-latex-recommended,
+    texlive-latex-extra,
+    texlive-generic-extra,
+    texlive-fonts-recommended
 Standards-Version: 3.9.5
 Homepage: https://github.com/epam/nfstrace/

## nfstrace 0.4.3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,12 +3,12 @@
 
 # check compiler and packages ==================================================
 if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
-    if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.8)
-        message (FATAL_ERROR "GCC version must be at least 4.8")
+    if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 5.1)
+        message (FATAL_ERROR "GCC version must be at least 5.1")
     endif ()
 elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
-    if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 3.3)
-        message (FATAL_ERROR "Clang version must be at least 3.3")
+    if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 3.5)
+        message (FATAL_ERROR "Clang version must be at least 3.5")
     endif ()
 else ()
     message (WARNING "Compilation by ${CMAKE_CXX_COMPILER_ID} ${CMAKE_CXX_COMPILER_VERSION} isn't tested")
@@ -30,7 +30,7 @@
 endif ()
 
 # build application ============================================================
-set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -pedantic -Wall -Werror -Wextra -fPIC -fvisibility=hidden")
+set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14 -pedantic -Wall -Werror -Wextra -Wno-invalid-offsetof -Wno-braced-scalar-init -fPIC -fvisibility=hidden")
 set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--export-dynamic")
 
 if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU" AND "${INCLUDE_COVERAGE_INFO}")
@@ -47,7 +47,14 @@
 
 set (NST_VERSION_FULL "${PROJECT_NAME} ${NST_VERSION} (${CMAKE_BUILD_TYPE})")
 
-string (TIMESTAMP COMPILATION_DATE "%Y-%m-%d")
+if (DEFINED ENV{SOURCE_DATE_EPOCH})
+    execute_process(
+      COMMAND "date" "-u" "-d" "@$ENV{SOURCE_DATE_EPOCH}" "+%Y-%m-%d"
+      OUTPUT_VARIABLE COMPILATION_DATE
+      OUTPUT_STRIP_TRAILING_WHITESPACE)
+else ()
+    string (TIMESTAMP COMPILATION_DATE "%Y-%m-%d")
+endif ()
 
 include_directories (src)
 
@@ -105,14 +112,7 @@
 add_subdirectory (docs)
 
 # code style ===================================================================
-find_program (ASTYLE_PATH astyle)
-
-if (ASTYLE_PATH)
-    add_custom_target (codestyle
-                       COMMAND find analyzers src tests -name '*.h' -o -name '*.cpp' |
-                               xargs ${ASTYLE_PATH} --options=${CMAKE_SOURCE_DIR}/astyle.cfg
-                       WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
-endif ()
+include ("cmake/codeformat.cmake")
 
 # valgrind reports =============================================================
 include ("cmake/valgrind.cmake")

=== analyzers/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.12)

# build analyzers ==============================================================
add_library (testanalyzer MODULE src/test/test_analyzer.cpp)

set_target_properties (testanalyzer
                       PROPERTIES LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/analyzers"
                       NO_SONAME ON)
# installation of plugins ======================================================
install (TARGETS testanalyzer LIBRARY DESTINATION lib/nfstrace)

# build analyzers (new way) ====================================================
add_subdirectory (src/watch)
add_subdirectory (src/breakdown)
add_subdirectory (src/json)

=== tests/functional/CMakeLists.txt ===
set (ANALYZER "breakdown")

set (CHECK_TRACE_SCRIPT_BASE "check-compressed-trace")
set (CHECK_TRACE_SCRIPT "${CHECK_TRACE_SCRIPT_BASE}-${ANALYZER}.sh")
configure_file ("${CHECK_TRACE_SCRIPT_BASE}.sh.in" "${CHECK_TRACE_SCRIPT}")

set (CHECK_DRANE_SCRIPT_BASE "check-compressed-drane")
set (CHECK_DRANE_SCRIPT "${CHECK_DRANE_SCRIPT_BASE}-${ANALYZER}.sh")
configure_file ("${CHECK_DRANE_SCRIPT_BASE}.sh.in" "${CHECK_DRANE_SCRIPT}")

set (CHECK_OUTPUT_SCRIPT_BASE "check-output")
set (CHECK_OUTPUT_SCRIPT "${CHECK_OUTPUT_SCRIPT_BASE}-${ANALYZER}.sh")
configure_file ("${CHECK_OUTPUT_SCRIPT_BASE}.sh.in" "${CHECK_OUTPUT_SCRIPT}")

# Adding trace/drane/output tests for each .pcap.bz2 trace
file (GLOB traces "${CMAKE_SOURCE_DIR}/traces/*.pcap.bz2")
foreach (trace ${traces})
	get_filename_component (name ${trace} NAME)
	get_filename_component (path ${trace} PATH)
	set (result ${CMAKE_BINARY_DIR}/Testing/Temporary/${name}-${ANALYZER}.res)
	set (reference ${path}/references/${ANALYZER}/${name}.ref)

	add_test (NAME functional_stat:${name} COMMAND sh ${CHECK_TRACE_SCRIPT} ${trace} ${result} ${reference})
	add_test (NAME functional_drain:${name} COMMAND sh ${CHECK_DRANE_SCRIPT} ${trace} ${result} ${reference})
	add_test (NAME functional_out:${name} COMMAND sh ${CHECK_OUTPUT_SCRIPT} ${trace})
endforeach ()

=== analyzers/src/watch/CMakeLists.txt ===
--- 
+++ 
@@ -2,15 +2,15 @@
 project (watch)
 
 # check system dependencies instructions =======================================
+set (CURSES_NEED_NCURSES TRUE)
 find_package (Curses) # find ncurses library
 
 # build instructions ===========================================================
 if (CURSES_FOUND)
     include_directories (${CMAKE_CURRENT_SOURCE_DIR})
     include_directories (${CURSES_INCLUDE_DIR})
-    file (GLOB_RECURSE UTILS ../utils/*.cpp)
     file (GLOB_RECURSE SRCS ./*.cpp)
-    add_library (${PROJECT_NAME} SHARED ${UTILS} ${SRCS})
+    add_library (${PROJECT_NAME} SHARED ${SRCS})
     set_target_properties(${PROJECT_NAME}
                           PROPERTIES LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/analyzers # direct output to nfstrace common binary dir
                           NO_SONAME ON)

=== debian/changelog ===
nfstrace (0.4.3.1-3) unstable; urgency=medium

  * Add an upstream patch to fix build on GCC 7 (Closes: #853571).

 -- Andrew Shadura <andrewsh@debian.org>  Sun, 03 Sep 2017 17:03:25 +0200

nfstrace (0.4.3.1-2) unstable; urgency=medium

  [ Chris Lamb ]
  * Make the PDF footers reproducible (Closes: #865751)

 -- Andrew Shadura <andrewsh@debian.org>  Sat, 24 Jun 2017 17:38:25 +0200

nfstrace (0.4.3.1-1) unstable; urgency=medium

  * New upstream release (Closes: #844859, #832069).
  * Update compiler dependencies.
  * Bump Standards-Version to 3.9.6 (no changes).

 -- Andrew Shadura <andrewsh@debian.org>  Thu, 15 Dec 2016 11:26:30 +0100

nfstrace (0.4.2-3) unstable; urgency=medium

  [ Steve Langasek ]
  * Fix FTBFS with gcc6. (Closes: #835644)

 -- Andrew Shadura <andrewsh@debian.org>  Tue, 04 Oct 2016 11:54:19 +0200

=== debian/rules ===
--- 
+++ 
@@ -4,11 +4,12 @@
 	dh $@
 
 override_dh_auto_build-indep:
-	cd docs; \
-	unset DISPLAY; \
-	loffice --headless --convert-to pdf nfstrace_manual.docx
-	# PlantUML not available :(
-	# $(MAKE) -C docs
+	dh_auto_build -- documentation
+
+ifneq (,$(filter $(DEB_HOST_ARCH),sparc64 x32))
+override_dh_auto_test-arch:
+	dh_auto_test || true
+endif
 
 override_dh_auto_test-indep:

=== debian/watch ===
--- 
+++ 
@@ -3,4 +3,5 @@
 
 version=3
 
+opts="filenamemangle=s/(?:.*?)??(\d[\d.]*)\.tar\.([gbx]z2?)/nfstrace-$1.tar.$2/" \
 https://github.com/epam/nfstrace/tags .*/(\d[\d\.]*)\.(?:tar.gz|tar.bz2|tar.xz)

## nfstrace 0.4.3.2

=== debian/changelog ===
nfstrace (0.4.3.2-1) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/copyright: Use https protocol in Format field.
  * d/control: Add Vcs-* field.

  [ Norbert Preining ]
  * Fix FTBFS with TeX Live 2018 (Closes: #896467).

  [ Andrej Shadura ]
  * New upstream release.
  * Add -Wno-class-memaccess -Wno-ignored-qualifiers to fix FTBFS with GCC-8
    (Closes: #897819).

 -- Andrej Shadura <andrewsh@debian.org>  Thu, 25 Oct 2018 18:44:57 +0200

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,11 @@
 Source: nfstrace
 Section: net
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Andrew Shadura <andrewsh@debian.org>
+Maintainer: Andrew Shadura <andrewsh@debian.org>
 Build-Depends:
     debhelper (>= 9),
     cmake,
-    g++ (>= 4.8) | clang (>= 3.3),
+    g++ (>= 5.1) | clang (>= 3.5),
     libpcap0.8-dev (>= 1.3),
     libgtest-dev,
     google-mock,
@@ -19,8 +18,10 @@
     texlive-latex-extra,
     texlive-generic-extra,
     texlive-fonts-recommended
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Homepage: https://github.com/epam/nfstrace/
+Vcs-Browser: https://salsa.debian.org/debian/nfstrace
+Vcs-Git: https://salsa.debian.org/debian/nfstrace.git
 
 Package: nfstrace
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,9 @@
 #!/usr/bin/make -f
+
+DPKG_EXPORT_BUILDFLAGS = 1
+include /usr/share/dpkg/buildflags.mk
+
+CXXFLAGS += -Wno-class-memaccess -Wno-ignored-qualifiers
 
 %:
 	dh $@

## nfstrace 0.4.3.2%2Bgit20180104%2B6561cf6

=== docs/CMakeLists.txt ===
add_custom_target (documentation)

find_package (Doxygen)
if (DOXYGEN_FOUND)
    add_custom_target (documentation-doxygen
                       COMMAND ${DOXYGEN_EXECUTABLE} Doxyfile
                       WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
    add_dependencies (documentation documentation-doxygen)
endif ()

find_package (LATEX COMPONENTS PDFLATEX)
file (GLOB_RECURSE TEXS "*.tex")
if (TEXS AND LATEX_PDFLATEX_FOUND)
    foreach (tex ${TEXS})
        get_filename_component (name ${tex} NAME_WE)
        set (pdf "${name}.pdf")
        list (APPEND PDFS ${pdf})
        set(args ${tex} -quiet -interaction=nonstopmode -halt-on-error -disable-installer -aux-directory=${CMAKE_CURRENT_BINARY_DIR})
        add_custom_command (OUTPUT ${pdf}
                            COMMAND ${PDFLATEX_COMPILER} ${args}
                            COMMAND ${PDFLATEX_COMPILER} ${args}
                            DEPENDS ${tex}
                            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
                            COMMENT "Converting ${tex} to ${pdf}" VERBATIM)
    endforeach ()
    add_custom_target (documentation-pdflatex DEPENDS ${PDFS} SOURCES ${TEXS})
    add_dependencies (documentation documentation-pdflatex)
endif ()

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: nfstrace
 Section: net
 Priority: optional
-Maintainer: Andrew Shadura <andrewsh@debian.org>
+Maintainer: Andrej Shadura <andrewsh@debian.org>
 Build-Depends:
-    debhelper (>= 9),
+    debhelper-compat (= 12),
     cmake,
     g++ (>= 5.1) | clang (>= 3.5),
     libpcap0.8-dev (>= 1.3),
@@ -16,7 +16,7 @@
     graphviz,
     texlive-latex-recommended,
     texlive-latex-extra,
-    texlive-generic-extra,
+    texlive-plain-generic,
     texlive-fonts-recommended
 Standards-Version: 3.9.6
 Homepage: https://github.com/epam/nfstrace/

## nfstrace 0.4.3.2%2Bgit20200805%2Bb220d04

=== analyzers/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required (VERSION 2.8.12)
+cmake_minimum_required (VERSION 3.0)
 
 # build analyzers ==============================================================
 add_library (testanalyzer MODULE src/test/test_analyzer.cpp)

## nfstrace 0.4.3.2+git20180104+6561cf6

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required (VERSION 2.8.12)
+cmake_minimum_required (VERSION 3.0)
 project (nfstrace)
 
 # check compiler and packages ==================================================

=== tests/CMakeLists.txt ===
add_subdirectory (functional)
add_subdirectory (unit)

=== tests/unit/CMakeLists.txt ===
if ("${GTEST_SOURCE_DIR}" STREQUAL "")
    message (WARNING "GTEST_SOURCE_DIR variable not set - unit-tests are not available. Use
    '-DGTEST_SOURCE_DIR=<path_to_nfstrace>/third_party/googletest' param for CMake")
else ()
    # Clang and GCC 4.9+ cause errors on GMock/GTest compilation, so we are adding following flags to suppress them
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-missing-field-initializers")
    if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
        set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-private-field")
    endif ()
    set (gmock_force_shared_crt true CACHE INTERNAL "")
    set (BUILD_SHARED_LIBS false CACHE INTERNAL "")
    add_definitions (-DGTEST_HAS_PTHREAD=1) # It fixes BUG in GTests in BSD
    add_subdirectory (${GTEST_SOURCE_DIR}/googlemock  ${CMAKE_BINARY_DIR}/gmock)
    set (GMOCK_LIBRARIES gmock gmock_main)
    set (GTEST_INCLUDE_DIRS
        "${GTEST_SOURCE_DIR}/googletest/include"
        "${GTEST_SOURCE_DIR}/googlemock/include")

    include_directories (${CMAKE_SOURCE_DIR}/src ${GTEST_INCLUDE_DIRS})

    add_subdirectory (utils)
    add_subdirectory (analyzers)
    add_subdirectory (protocols)
    add_subdirectory (filtration)
endif ()

=== analyzers/src/json/CMakeLists.txt ===
set (CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake")
find_package (JSON)

if (JSON_FOUND)
    project (json)
    aux_source_directory ("." SRC_LIST)
    add_library (${PROJECT_NAME} SHARED ${SRC_LIST}
            ../../../src/utils/log.cpp
            ../../../src/utils/out.cpp)
    set_target_properties(${PROJECT_NAME} PROPERTIES
            LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/analyzers) # direct output to nfstrace common binary dir
    include_directories (${JSON_INCLUDE_DIRS})
    target_link_libraries (${PROJECT_NAME} ${JSON_LIBRARIES})
    install (TARGETS ${PROJECT_NAME} LIBRARY DESTINATION lib/nfstrace)
else ()
    message (WARNING "JSON library not found - JSON analyzer plugin is not available!")
endif ()

=== debian/changelog ===
nfstrace (0.4.3.2+git20180104+6561cf6-1) unstable; urgency=medium

  * New upstream snapshot.
  * Add a watch line for Git snapshots.
  * Add FTBFS fixes by Nick Black.
  * Use debhelper-compat 12.
  * Ignore test failures on all architectures.
  * Remove unrecognised -Wno-braced-scalar-init,
    add -Wno-error=address-of-packed-member until a proper fix is written.
    Closes: #925788.
  * Build-depend on texlive-plain-generic (Closes: #933288).
  * Remove no longer necessary -Wno-class-memaccess -Wno-ignored-qualifiers.

 -- Andrej Shadura <andrewsh@debian.org>  Sat, 22 Feb 2020 12:04:40 +0200

=== debian/watch ===
# watch control file for uscan
# See uscan(1) for how to set this file properly

version=4

opts="filenamemangle=s/(?:.*?)??(\d[\d.]*)\.tar\.([gbx]z2?)/nfstrace-$1.tar.$2/" \
https://github.com/epam/nfstrace/tags .*/(\d[\d\.]*)\.(?:tar.gz|tar.bz2|tar.xz)

opts="mode=git, pgpmode=none, pretty=0.4.3.2+git%cd+%h, repack, compression=xz" \
 https://github.com/epam/nfstrace.git \
 HEAD

## nfstrace 0.4.3.2+git20200805+b220d04

=== CMakeLists.txt ===
--- 
+++ 
@@ -30,7 +30,7 @@
 endif ()
 
 # build application ============================================================
-set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14 -pedantic -Wall -Werror -Wextra -Wno-invalid-offsetof -Wno-braced-scalar-init -fPIC -fvisibility=hidden")
+set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14 -pedantic -Wall -Werror -Wextra -Wno-invalid-offsetof -Wno-error=address-of-packed-member -fPIC -fvisibility=hidden")
 set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--export-dynamic")
 
 if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU" AND "${INCLUDE_COVERAGE_INFO}")

=== tests/functional/CMakeLists.txt ===
--- 
+++ 
@@ -12,6 +12,10 @@
 set (CHECK_OUTPUT_SCRIPT "${CHECK_OUTPUT_SCRIPT_BASE}-${ANALYZER}.sh")
 configure_file ("${CHECK_OUTPUT_SCRIPT_BASE}.sh.in" "${CHECK_OUTPUT_SCRIPT}")
 
+set (CHECK_COMMAND_SCRIPT_BASE "check-command")
+set (CHECK_COMMAND_SCRIPT "${CHECK_COMMAND_SCRIPT_BASE}-${ANALYZER}.sh")
+configure_file ("${CHECK_COMMAND_SCRIPT_BASE}.sh.in" "${CHECK_COMMAND_SCRIPT}")
+
 # Adding trace/drane/output tests for each .pcap.bz2 trace
 file (GLOB traces "${CMAKE_SOURCE_DIR}/traces/*.pcap.bz2")
 foreach (trace ${traces})
@@ -23,5 +27,6 @@
 	add_test (NAME functional_stat:${name} COMMAND sh ${CHECK_TRACE_SCRIPT} ${trace} ${result} ${reference})
 	add_test (NAME functional_drain:${name} COMMAND sh ${CHECK_DRANE_SCRIPT} ${trace} ${result} ${reference})
 	add_test (NAME functional_out:${name} COMMAND sh ${CHECK_OUTPUT_SCRIPT} ${trace})
+	add_test (NAME functional_command:${name} COMMAND sh ${CHECK_COMMAND_SCRIPT} ${trace})
 endforeach ()

=== analyzers/src/watch/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,3 @@
-cmake_minimum_required (VERSION 2.8.12)
 project (watch)
 
 # check system dependencies instructions =======================================

=== tests/unit/filtration/CMakeLists.txt ===
project (unit_test_filtration)
aux_source_directory ("." SRC_TEST_LIST)
aux_source_directory (${CMAKE_SOURCE_DIR}/src/protocols/cifs SRC_TEST_LIST)
aux_source_directory (${CMAKE_SOURCE_DIR}/src/protocols/cifs2 SRC_TEST_LIST)
aux_source_directory (${CMAKE_SOURCE_DIR}/src/protocols/nfs SRC_TEST_LIST)
aux_source_directory (${CMAKE_SOURCE_DIR}/src/protocols/netbios SRC_TEST_LIST)
add_executable (${PROJECT_NAME} ${SRC_TEST_LIST}
    ${CMAKE_SOURCE_DIR}/src/utils/out.cpp
    ${CMAKE_SOURCE_DIR}/src/utils/log.cpp
    ${CMAKE_SOURCE_DIR}/src/utils/sessions.cpp
)
target_link_libraries (${PROJECT_NAME} ${GMOCK_LIBRARIES})
add_test (${PROJECT_NAME} ${PROJECT_NAME})

=== tests/unit/protocols/CMakeLists.txt ===
project (unit_test_protocols)
aux_source_directory ("." SRC_TEST_LIST)
aux_source_directory (${CMAKE_SOURCE_DIR}/src/protocols/cifs2/ SRC_TEST_LIST)
aux_source_directory (${CMAKE_SOURCE_DIR}/src/protocols/nfs/ SRC_TEST_LIST)

add_executable (${PROJECT_NAME} ${SRC_TEST_LIST}
    ${CMAKE_SOURCE_DIR}/src/utils/out.cpp
    ${CMAKE_SOURCE_DIR}/src/utils/log.cpp
    ${CMAKE_SOURCE_DIR}/src/utils/sessions.cpp
)

target_link_libraries (${PROJECT_NAME} ${GMOCK_LIBRARIES})
add_test (${PROJECT_NAME} ${PROJECT_NAME})

=== tests/unit/utils/CMakeLists.txt ===
project (unit_test_utils)
aux_source_directory ("." SRC_TEST_LIST)
add_executable (${PROJECT_NAME} ${SRC_TEST_LIST})
target_link_libraries (${PROJECT_NAME} ${GMOCK_LIBRARIES})
add_test (${PROJECT_NAME} ${PROJECT_NAME})

=== tests/unit/analyzers/breakdown/CMakeLists.txt ===
project (unit_test_breakdown)
aux_source_directory ("." SRC_LIST)
aux_source_directory ("${CMAKE_SOURCE_DIR}/analyzers/src/breakdown" SRC_LIST)
aux_source_directory (${CMAKE_SOURCE_DIR}/src/protocols/cifs SRC_LIST)
aux_source_directory (${CMAKE_SOURCE_DIR}/src/protocols/nfs SRC_LIST)
aux_source_directory (${CMAKE_SOURCE_DIR}/src/protocols/nfs3 SRC_LIST)
aux_source_directory (${CMAKE_SOURCE_DIR}/src/protocols/nfs4 SRC_LIST)
aux_source_directory (${CMAKE_SOURCE_DIR}/src/utils SRC_LIST)

add_executable(${PROJECT_NAME} ${SRC_LIST})

include_directories ("${CMAKE_SOURCE_DIR}/analyzers/src/breakdown/")
target_link_libraries (${PROJECT_NAME} ${GMOCK_LIBRARIES} ${CMAKE_DL_LIBS})
add_test (${PROJECT_NAME} ${PROJECT_NAME})

=== debian/changelog ===
nfstrace (0.4.3.2+git20200805+b220d04-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with CMake 4. (Closes: #1113323)

 -- Adrian Bunk <bunk@debian.org>  Sat, 11 Oct 2025 14:30:27 +0300

nfstrace (0.4.3.2+git20200805+b220d04-4) unstable; urgency=medium

  * Add nocheck and nodoc build profiles.
  * Use intmax_t and the corresponding format specifier when dealing with time_t
    (Closes: #1068029)

 -- Andrej Shadura <andrewsh@debian.org>  Sun, 07 Apr 2024 14:53:20 +0200

nfstrace (0.4.3.2+git20200805+b220d04-3) unstable; urgency=medium

  [ Sven Joachim ]
  * Fix FTBFS with opaque ncurses (Closes: #1057580)

  [ Andrej Shadura ]
  * Add patch metadata.
  * Update standards version to 4.6.2, no changes needed.
  * Set Rules-Requires-Root: no.

 -- Andrej Shadura <andrewsh@debian.org>  Thu, 21 Dec 2023 20:48:27 +0100

nfstrace (0.4.3.2+git20200805+b220d04-2.2) unstable; urgency=medium

  * Non-maintainer upload
  * debian/patches/0001-analyzers-fix-a-couple-format-errors.patch: Refresh to
    address format errors on armhf.
  * debian/patches/debian/patches/watch-analyzer-fix-array-bound-error.patch:
    Take the relevant parts of an upstream patch to fix an array bound build
    error.

 -- Nick Rosbrook <nick.rosbrook@canonical.com>  Fri, 18 Mar 2022 09:47:25 -0400

nfstrace (0.4.3.2+git20200805+b220d04-2.1) unstable; urgency=medium

  * Non-maintainer upload
  * debian/patches/0001-analyzers-fix-a-couple-format-errors.patch: Fix
    -Werror=format build errors (LP: #1965155, Closes: #997231).

 -- Nick Rosbrook <nick.rosbrook@canonical.com>  Thu, 17 Mar 2022 13:21:02 -0400

nfstrace (0.4.3.2+git20200805+b220d04-2) unstable; urgency=medium

  [ Aurelien Jarno ]
  * Switch to the TI RPC implementation (Closes: #992960).

  [ Andrej Shadura ]
  * Wrap long lines in changelog entries: 0.4.3.2+git20200805+b220d04-1.
  * Bump debhelper from old 12 to 13.
  * Fix broken Vcs URL.

 -- Andrej Shadura <andrewsh@debian.org>  Thu, 26 Aug 2021 12:08:31 +0200

nfstrace (0.4.3.2+git20200805+b220d04-1) unstable; urgency=medium

  * New upstream snapshot (Closes: #966600).
  * Drop patches applied upstream.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Bump Standards-Version to 4.5.0.
  * Fix Vcs-*.

 -- Andrej Shadura <andrewsh@debian.org>  Sat, 15 Aug 2020 16:04:38 +0200

=== debian/control ===
--- 
+++ 
@@ -3,25 +3,28 @@
 Priority: optional
 Maintainer: Andrej Shadura <andrewsh@debian.org>
 Build-Depends:
-    debhelper-compat (= 12),
+    debhelper-compat (= 13),
     cmake,
     g++ (>= 5.1) | clang (>= 3.5),
     libpcap0.8-dev (>= 1.3),
-    libgtest-dev,
-    google-mock,
+    libgtest-dev <!nocheck>,
+    google-mock <!nocheck>,
     libncurses5-dev,
-    libjson-c-dev
+    libjson-c-dev,
+    libtirpc-dev,
+    pkgconf | pkg-config
 Build-Depends-Indep:
-    doxygen,
-    graphviz,
-    texlive-latex-recommended,
-    texlive-latex-extra,
-    texlive-plain-generic,
-    texlive-fonts-recommended
-Standards-Version: 3.9.6
+    doxygen <!nodoc>,
+    graphviz <!nodoc>,
+    texlive-latex-recommended <!nodoc>,
+    texlive-latex-extra <!nodoc>,
+    texlive-plain-generic <!nodoc>,
+    texlive-fonts-recommended  <!nodoc>,
+Standards-Version: 4.6.2
 Homepage: https://github.com/epam/nfstrace/
 Vcs-Browser: https://salsa.debian.org/debian/nfstrace
 Vcs-Git: https://salsa.debian.org/debian/nfstrace.git
+Rules-Requires-Root: no
 
 Package: nfstrace
 Architecture: any
@@ -43,6 +46,7 @@
 Package: nfstrace-doc
 Architecture: all
 Depends: ${misc:Depends}
+Build-Profiles: <!nodoc>
 Description: NFS tracing/monitoring/capturing/analyzing tool (documentation)
  nfstrace captures live NFS traffic and performs filtering, statistical
  analysis, visualisation and more. It also provides an API for custom

=== debian/rules ===
--- 
+++ 
@@ -1,20 +1,17 @@
 #!/usr/bin/make -f
-
-DPKG_EXPORT_BUILDFLAGS = 1
-include /usr/share/dpkg/buildflags.mk
-
-CXXFLAGS += -Wno-class-memaccess -Wno-ignored-qualifiers
 
 %:
 	dh $@
 
+ifeq (,$(filter nodoc,$(DEB_BUILD_PROFILES)))
 override_dh_auto_build-indep:
 	dh_auto_build -- documentation
+endif
 
-ifneq (,$(filter $(DEB_HOST_ARCH),sparc64 x32))
+#ifneq (,$(filter $(DEB_HOST_ARCH),sparc64 x32))
 override_dh_auto_test-arch:
 	dh_auto_test || true
-endif
+#endif
 
 override_dh_auto_test-indep:
